<?php
/*
 *  Created by Ingo Koinzer <ingo@gkoinzer.de>
 *
 *  Only for use with the PC_DIMMER project, http://www.pcdimmer.de/
 *  
 *  Script for rendering the PC_DIMMER control panel in as an html document.
 */

 // Open a TCP connection to the PC_DIMMER terminal server.
$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
if (!socket_connect($socket, "localhost", 10160))
    die ("Connection failed.");

// Check wether a request for clicking a button is sent.
if (isset($_GET['x']) && isset($_GET['y']))
{
		//Send the request to PC_DIMMER and exit the script.
    socket_write($socket, "click_btn ".trim($_GET['y'])." ".trim($_GET['x'])."\r\n");
    echo "Drcke Btn ".$_GET['x']."|".$_GET['y'].".";
    socket_close($socket);
    exit;
}

// Get the whole control panel contents
socket_write($socket, "get_controlpanel 0 0\r\n");

$read = socket_read($socket, 512, PHP_NORMAL_READ);

$read = socket_read($socket, 512, PHP_NORMAL_READ);

$read = socket_read($socket, 3554432, PHP_NORMAL_READ);

$buttondata = explode(", ", $read);
$buttons = array();
$row = -1;
$col = -1;
foreach ($buttondata as $buttondate)
{
    $keyvalue = explode(":", $buttondate);
    if ($keyvalue[0] == "button")
    {
        trim($keyvalue[1]);           
        $coordinates = explode("x", $keyvalue[1]);
        if ($row < ($coordinates[0] - 1))
        {
            $row++;
            $buttons[$row] = array();
            $col = -1;
        }
        if ($col < ($coordinates[1] - 1))    
        {
            $col++;
            $buttons[$row][$col] = array();
        }                       
        $buttons[$row][$col]["coords"] = $coordinates;        
    }
    $buttons[$row][$col][$keyvalue[0]] = $keyvalue[1]; 
}

// Render the buttons in a html file as a table and send it to the client.
include "PCD_Terminal.tpl"; 

// Close the socket.
socket_close($socket);

          


/* End of file */
?>